]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame_incremental - rpm.macros
- switch last users of kgcc to __cc
[packages/rpm-build-macros.git] / rpm.macros
... / ...
CommitLineData
1# vim:ts=4 sw=4 noet ft=spec
2#
3# PLD Linux rpm macros.
4# <http://www.pld-linux.org/>
5
6# can be used by builder script to check for version
7%rpm_build_macros {Revision}
8
9%epoch 0
10%x8664 x86_64 amd64 ia32e
11%arm armv3l armv4b armv4l armv5teb armv5tel
12
13# compiler version
14%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion 2>/dev/null || echo 0.0)}%cc_version
15%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion 2>/dev/null || echo 0.0)}%cxx_version
16
17%__rm /bin/rm --interactive=never
18
19# Build system path macros.
20%__autoconf autoconf %{?debug:-Wall}
21%__automake automake -a -c -f --foreign
22%__autopoint autopoint --force
23
24# add parallel build flags: -jN
25# jobs macro is available since 1.657
26#
27# if you want to disable parallel build do:
28# echo '%__jobs %{nil}' >> ~/.rpmmacros
29%__jobs %{expand:%%global __jobs %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); [ "$_NCPUS" -gt 3 ] && echo $(($_NCPUS / 2)))%%{nil}}%__jobs
30
31# expands to -jN if %__jobs has a value
32%_smp_mflags %{expand:%%global _smp_mflags %(jobs=%{__jobs}; echo ${jobs:+-j$jobs}%%{nil})}%_smp_mflags
33
34%__make /usr/bin/make %{?_smp_mflags}
35%__scons /usr/bin/scons %{?_smp_mflags}
36%__waf /usr/bin/waf %{?_smp_mflags}
37%__cmake /usr/bin/cmake
38
39%__gettextize { \
40 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
41 gettextize --copy --force --no-changelog; \
42 else \
43 gettextize --copy --force --no-changelog --intl; \
44 fi; \
45 if [ ! -f po/Makevars ]; then \
46 cp -f po/Makevars{.template,}; \
47 fi; \
48}
49
50%__glib_gettextize glib-gettextize --copy --force
51%__gnome_doc_common gnome-doc-common --copy
52%__gnome_doc_prepare gnome-doc-prepare --copy --force
53%__gtkdocize gtkdocize --copy
54%__intltoolize intltoolize --copy --force
55%__libtoolize libtoolize --copy --force --install
56
57# topdir is where builder script lives,
58# fallback to old style if SPECS/SOURCES dirs were found.
59%_topdir %{expand:%%global _topdir %(
60 if [ -d SPECS -a -d SOURCES ]; then
61 # old style rpmdir: in topdir
62 pwd
63 elif [ -d ../SPECS -a -d ../SOURCES ]; then
64 # old style rpmdir: in subdir
65 cd ..; pwd
66 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
67 # if old style rpm dir exist, go with it
68 echo $HOME/rpm; \
69 elif [ -x ../builder -a ! -d ../builder ]; then
70 # relative new style rpmdir: in package dir
71 cd ..; pwd
72 elif [ -x builder -a ! -d builder ]; then
73 # relative new style rpmdir: in packages
74 pwd
75 elif [ -x packages/builder -a ! -d packages/builder ]; then
76 # relative new style rpmdir: packages dir in current dir
77 cd packages; pwd
78 else
79 # fallback to new style rpmdir
80 echo $HOME/rpm/packages
81 fi; \
82)}%_topdir
83
84# if %{_topdir}/SPECS exists, it's old style structure
85%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
86%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
87
88# BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
89# if they don't exist assume we are having custom topdir (which is not named as
90# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
91# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therfore the extra echo
92%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
93%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
94%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
95
96# The number of cvs changelog entries kept when building package.
97%_buildchangelogtruncate 20
98
99%dependencytracking %{nil}
100
101# Relations between package names that cause dependency loops
102# with legacy packages that cannot be fixed. Relations are
103# specified as
104# p>q
105# where package p has a Requires: on something that package q Provides:
106#
107# XXX Note: that there cannot be any whitespace within the string "p>q",
108# and that both p and q are package names (i.e. no version/release).
109%_dependency_whiteout %{nil}
110
111#-----------------------------------------------------------------
112#
113# (re)definition of %{rpm*flags} with %filterout_* support
114# BuildRequires: awk
115# BuildRequires: rpmbuild(macros) >= 1.315
116#
117# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
118# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
119# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
120# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
121# %rpmldflags = %optldflags - %filterout_ld
122#
123# Regular expressions are supported, but to avoid some character be treated
124# as regular expression it must be escaped twice.
125
126%filter_out \
127 for (i = 1; i in I; i++) { A=0; \
128 for (f in F) { \
129 if (I[i] ~ "^" F[f] "$") A=1; \
130 }; \
131 if (!A) printf(I[i] FS); \
132 }
133
134%rpmcflags %(awk 'BEGIN {
135 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
136 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
137 %{filter_out}
138}')
139
140%rpmcxxflags %(awk 'BEGIN {
141 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
142 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
143 %{filter_out}
144}')
145
146%rpmcppflags %(awk 'BEGIN {
147 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
148 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
149 %{filter_out}
150}')
151
152%rpmldflags %(awk 'BEGIN {
153 split("%{?optldflags}",I);
154 split("%{?filterout_ld}",F)
155 %{filter_out}
156}')
157
158# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
159# but, don't use it, better use gcc as linker
160%ld_rpmldflags %(awk 'BEGIN {
161 split("%{rpmldflags}",F);
162 for (f in F) {
163 s = F[f];
164 if (s ~ /^-Wl,/) {
165 s = substr(s,5);
166 gsub(/,/," ",s);
167 };
168 printf(s FS);
169 };
170}')
171
172#-----------------------------------------------------------------
173#
174# Generate a command which cleans environment, leaving only the
175# most important variables.
176# If any spec requires any additional environment it should
177# redefine %_preserve_env in following manner:
178#
179# # ADDITIONAL_VAR is required because [a good reason here]
180# %define _preserve_env ADDITIONAL_VAR
181
182%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
183
184# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
185%_clean_env env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
186 split("%{?_preserve_env:%_preserve_env %_preserve_env_base}%{!?_preserve_env:%_preserve_env_base}", P);
187 for (i in P) {
188 p = P[i];
189 if (!ENVIRON[p] || d[p]) {
190 continue;
191 }
192 d[p] = 1;
193 split(ENVIRON[p], V, "");
194 val = p "=";
195 for (j = 1; j in V; j++) {
196 v = V[j];
197 if (v == q)
198 v = qq;
199 else if (v == "\\"")
200 v = q2q;
201 else if (v == "\\\\")
202 v = "\\\\\\\\";
203 else
204 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
205 val = val "" v;
206 }
207 printf(val " ");
208 }
209}')
210
211#-----------------------------------------------------------------
212%configure2_13 { \
213 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
214 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
215 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
216 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
217 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
218 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
219 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
220 %{?__cc:CC="%{__cc}" ; export CC ; } \
221 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
222 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
223 --host=%{_target_platform} \
224 --prefix=%{_prefix} \
225 --exec-prefix=%{_exec_prefix} \
226 --bindir=%{_bindir} \
227 --sbindir=%{_sbindir} \
228 --sysconfdir=%{_sysconfdir} \
229 --datadir=%{_datadir} \
230 --includedir=%{_includedir} \
231 --libdir=%{_libdir} \
232 --libexecdir=%{_libexecdir} \
233 --localstatedir=%{_localstatedir} \
234 --sharedstatedir=%{_sharedstatedir} \
235 --mandir=%{_mandir} \
236 --infodir=%{_infodir} \
237 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
238 %{dependencytracking} \
239}
240
241%cmake \
242%{?__cc:CC="${CC:-%{__cc}}"} \\\
243%{?__cxx:CXX="${CXX:-%{__cxx}}"} \\\
244CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \\\
245%{__cmake} \\\
246 -DCMAKE_VERBOSE_MAKEFILE=ON \\\
247 -DCMAKE_BUILD_TYPE=%{!?debug:PLD}%{?debug:Debug} \\\
248 -DCMAKE_INSTALL_LIBDIR:PATH=%{_libdir} \\\
249 -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \\\
250 -DINCLUDE_INSTALL_DIR:PATH=%{_includedir} \\\
251 -DLIB_INSTALL_DIR:PATH=%{_libdir} \\\
252 -DSHARE_INSTALL_PREFIX:PATH=%{_datadir} \\\
253 -DSYSCONF_INSTALL_DIR:PATH=%{_sysconfdir} \\\
254 -DCMAKE_CXX_FLAGS_PLD="${CXXFLAGS:-%{rpmcxxflags} -DNDEBUG}" \\\
255 -DCMAKE_C_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG}" \\\
256 -DCMAKE_Fortran_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG}" \\\
257 -DCMAKE_EXE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
258 -DCMAKE_SHARED_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
259 -DCMAKE_MODULE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
260%if "%{_lib}" == "lib64" \
261 -DLIB_SUFFIX=64 \\\
262%endif \
263 -DBUILD_SHARED_LIBS:BOOL=ON \\\
264%{nil}
265
266%scons { \
267%{__scons} \
268 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
269 CFLAGS="${CFLAGS:-%rpmcflags}" \
270 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
271 FFLAGS="${FFLAGS:-%rpmcflags}" \
272 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
273 %{?__cc:CC="%{__cc}"} \
274 %{?__cxx:CXX="%{__cxx}"} \
275 libsuffix=%{_lib} \
276 prefix=%{_prefix} \
277}
278
279# waf. see waf.spec
280%waf { \
281CC="%{__cc}" \
282CXX="%{__cxx}" \
283CPP="%{__cpp}" \
284CFLAGS="%{rpmcflags}" \
285CXXFLAGS="%{rpmcxxflags}" \
286%{__waf} \
287}
288
289#----------------------------------------------------------------
290#%configure_cache 0
291%configure_cache_file %{buildroot}.configure.cache
292
293%configure {./configure \
294 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
295 CFLAGS="${CFLAGS:-%rpmcflags}" \
296 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
297 FFLAGS="${FFLAGS:-%rpmcflags}" \
298 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
299 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
300 %{?__cc:CC="%{__cc}"} \
301 %{?__cxx:CXX="%{__cxx}"} \
302 --host=%{_target_platform} \
303 --build=%{_target_platform} \
304 --prefix=%{_prefix} \
305 --exec-prefix=%{_exec_prefix} \
306 --bindir=%{_bindir} \
307 --sbindir=%{_sbindir} \
308 --sysconfdir=%{_sysconfdir} \
309 --datadir=%{_datadir} \
310 --includedir=%{_includedir} \
311 --libdir=%{_libdir} \
312 --libexecdir=%{_libexecdir} \
313 --localstatedir=%{_localstatedir} \
314 --sharedstatedir=%{_sharedstatedir} \
315 --mandir=%{_mandir} \
316 --infodir=%{_infodir} \
317 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
318 %{dependencytracking} \
319 %{?configure_cache:--cache-file=%{configure_cache_file}} \
320}
321
322# Simple macros to simplify adding bconded options to configure scripts.
323# Each macro requires bcond name and accepts optional option name, if option
324# isn't specified bcond name is used as option name. Options returning
325# --with and --enable also allow third argument which will be added as value
326# ( --with-option=value or --enable-option=value ) in case or positive
327# condition, but won't be added otherwise ( nothing or just --disable-option ).
328
329# Requirements:
330# BuildRequires: rpmbuild(macros) >= 1.527
331
332# Usage example:
333# %{__enable bcond} - returns --enable-bcond iff build condition is set
334# %{__disable bcond option} - returns --enable-option iff bcond is not set
335# %{__enable_disable bcond option value} - returns --enable-option=value if
336# bcond is set, returns --disable-option otherwise
337
338# expand bconds to --enable-something and --disable-something
339%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
340%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
341%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
342
343# same as above, but condition inverted
344%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
345%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
346%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
347
348# expand bconds to --with-something and --without-something
349%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
350%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
351%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
352
353# same as above, but condition inverted
354%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
355%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
356%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
357
358#-----------------------------------------------------------------
359
360# overload to insert debuginfo package
361%prep \
362%if 0%{?_enable_debug_packages}\
363%{debug_package}\
364%endif\
365%%prep\
366%{nil}
367
368# Location of autoconf macros
369%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
370
371# Location of omf files
372%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
373
374# Location of pkgconfig files
375%_pkgconfigdir /usr/%{_lib}/pkgconfig
376# noarch pkgconfig files
377%_npkgconfigdir /usr/share/pkgconfig
378
379# Location of desktop files
380%_desktopdir /usr/share/applications
381%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
382
383# Location of pixmaps for applnk/desktop files
384%_pixmapsdir /usr/share/pixmaps
385
386# Location of themable icons for applnk/desktop files
387%_iconsdir /usr/share/icons
388
389# Location of fonts directories
390%_fontsdir /usr/share/fonts
391
392# Location of Gtk and associated libraries documentation
393%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
394
395# Location of KDE documentation
396%_kdedocdir %{_defaultdocdir}/kde/HTML
397
398# unsermake script
399%__unsermake /usr/share/unsermake/unsermake
400
401# Current date
402%date %(LC_ALL=C date +"%a %b %d %Y")
403
404# Example files, programs, scripts...
405%_examplesdir /usr/src/examples
406
407# SysV-style initscripts dir
408%_initddir /etc/rc.d/init.d
409
410# If non-empty "debug" macro defined, add "dbg" suffix to release number
411%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
412
413# Bootstrap release macros.
414# Usage:
415# %bcond_with bootstrap
416# Release: %{bootstrap_release 1}
417#
418# Package will have release 1 if built normally,
419# and release 0.zzz.bootstrap if built with bootstrap
420%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
421
422# Alternative kernel type/version
423%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
424
425# The directory holding Linux kernel sources
426%_kernelsrcdir /usr/src/linux%{_alt_kernel}
427
428# rpm -qf on kernel version.h file
429%__kernel_qf() %(R=$(cd %{_kernelsrcdir} 2>/dev/null && LC_ALL=C rpm -q --qf '%*' -f include/linux/version.h 2>/dev/null | grep -v 'is not'); echo ${R:-ERROR})
430
431# kernel %{name} and kernel %{epoch}:%{version}-%{release} macro respecing alt_kernel
432%kernel_name %(N=%{__kernel_qf %{N}}; echo ${N%%-headers})
433%kernel_version %{__kernel_qf %|E?{%{E}:}|%{V}-%{R}}
434
435# -n drm to generate kernel%{_alt_kernel}-drm dependency
436%releq_kernel(n:) %{kernel_name}%{?-n:-%{-n*}} = %{kernel_version}
437%releq_kernel_up(n:) %{kernel_name}-up%{?-n:-%{-n*}} = %{kernel_version}
438%releq_kernel_smp(n:) %{kernel_name}-smp%{?-n:-%{-n*}} = %{kernel_version}
439
440# -s post to generate Requires(post) dependency
441%requires_releq_kernel(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel
442%requires_releq_kernel_up(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_up
443%requires_releq_kernel_smp(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
444
445# kernel version-release handling
446%__kernel_ver %( \\
447 Z=$([ -f '%{_kernelsrcdir}/include/generated/utsrelease.h' ] && awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/{linux/version,generated/utsrelease}.h 2>/dev/null || awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
448 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
449 echo ${Z:-ERROR}; \\
450)
451
452%__kernel_rel %{__kernel_qf %{R}}
453%__kernel_rpmvr %{__kernel_qf %{V}-%{R}}
454%_kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
455%_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
456
457# `uname -r` to be used in @release field
458%_kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')
459
460# Requires name = version-release
461%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
462# Requires: name = version
463%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
464# Requires: name = version (version based on querying package %2)
465%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
466
467# Requires: name >= version
468%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
469# Requires: name >= version (version based on querying package %2)
470%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
471
472# \helper for renaming packages
473# %rename old-package
474%rename() \
475Obsoletes: %{1} < %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}} \
476Provides: %{1} = %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}}
477
478%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
479
480# sgml macros
481%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
482%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
483%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
484%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
485%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
486%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
487%docbook_sgmlcat_fix() { for l in \
488'' \
489' -- default decl --' \
490'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
491' -- hacks for opensp --' \
492'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
493'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
494'' \
495; do echo $l; done >> %1 \
496}
497
498# vim - "
499
500# minimum file size needed for compressed documents.
501# just smaller files than this get larger when compressed.
502# some stats:
503# - 0 byte file compressed was 25 bytes .gz
504# - 39 byte file was compressed as 57
505# - with test/test.spec@man 158 byte file was compressed also 158
506%_min_compress_bytes 159
507
508#-----------------------------------------------------------------
509# find and gzip all files in %{_mandir} and %{infodir}
510#
511# Requires: xargs, find
512#
513#%no_install_post_compress_docs 1
514%__spec_install_post_compress_docs { \
515%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
516 %{!?debug:set +x;} \
517 for i in /usr/share/man /usr/X11R6/man; do \
518 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
519 echo "Compress man pages: $i"; \
520 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
521 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
522 find $RPM_BUILD_ROOT$i -type l | while read a; do \
523 m=$(readlink "$a"); \
524 if [[ "$m" = */* ]]; then \
525 # handle links to different man section \
526 l=$(readlink -f "$a"); \
527 # full/relative paths that resolve symlink \
528 l=${l#$RPM_BUILD_ROOT/usr/share/man/}; \
529 l=${l#$RPM_BUILD_ROOT/usr/X11R6/man/}; \
530 # full paths that do not resolve symlink \
531 l=${l#/usr/share/man/}; \
532 l=${l#/usr/X11R6/man/}; \
533 else \
534 l=${a#$RPM_BUILD_ROOT$i/}; \
535 l=${l%/*}; \
536 l="$l/$m"; \
537 fi; \
538 rm -f $a; \
539 echo ".so $l" > $a; \
540 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: $l"; \
541 done; \
542 # verify that .so links point to existing files (not allowed to point to "other package") \
543 # TODO: iterate over all man dirs, but in Th there is only one true man dir \
544 err=$(grep -rl '^\.so ' "$RPM_BUILD_ROOT$i" | while read doc; do \
545 l=$(grep -r '^\.so ' "$doc"); \
546 l=${l#.so }; \
547 d=$(dirname $doc); \
548 test -e $RPM_BUILD_ROOT$i/$l || test -e $d/$(basename $l) || echo " ${doc#$RPM_BUILD_ROOT} points to inexistent manpage: $l"; \
549 done); \
550 test "$err" != "" && { echo >&2 "Man page link errors:"; echo >&2 "$err"; exit 1; }; \
551 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
552 fi; \
553 done; \
554 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
555 echo "Compress info pages: %{_infodir}"; \
556 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
557 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
558 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
559 fi; \
560}; __spec_install_post_compress_docs } }
561
562#-----------------------------------------------------------------
563# Strip executable binaries and shared object files
564#
565# Requires: find, awk, strip, cut, xargs
566#
567# Special macros which affect this process:
568#%no_install_post_strip 1 # disable stripping at all
569#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
570#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
571#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
572#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
573#
574%__spec_install_post_strip {%{!?debug: \
575%{!?no_install_post_strip:__spec_install_post_strip() { \
576%{!?debug:set +x;} \
577if [ -d "$RPM_BUILD_ROOT" ]; then \
578 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
579 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
580 if [ "$modulelist" ]; then \
581 modulecount=$(echo "$modulelist" | wc -l); \
582 printf "Stripping %d kernel modules..." $modulecount; \
583 echo "$modulelist" | xargs -l512 chmod u+w; \
584 echo "$modulelist" | xargs -l512 %{__strip} -g --remove-section=.comment --remove-section=.note.GNU-stack; \
585 echo "DONE"; \
586 fi; \
587 fi; \
588 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
589 if [ -n "$filelist" ]; then \
590 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
591 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
592 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
593 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
594 if [ -n "$elfexelist" ]; then \
595 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
596 echo "$elfexelist" | xargs -r -d'\n' chmod u+w; \
597 echo "$elfexelist" | xargs -r -d'\n' %{__strip} --remove-section=.note --remove-section=.comment; \
598 echo "DONE"; \
599 fi; \
600 if [ -n "$elfsharedlist" ]; then \
601 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
602 echo "$elfsharedlist" | xargs -r -d'\n' chmod u+w; \
603 echo "$elfsharedlist" | xargs -r -d'\n' %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment; \
604 echo "DONE"; \
605 fi; \
606 if [ -n "$archiveslist" ]; then \
607 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
608 echo "$archiveslist" | xargs -r -d'\n' chmod u+w; \
609 echo "$archiveslist" | xargs -r -d'\n' %{__strip} --strip-debug --remove-section=.note --remove-section=.comment; \
610 echo "DONE"; \
611 fi; \
612 fi; \
613 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
614 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
615 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
616 if [ -n "$filelist_all" ]; then \
617 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
618 chmod u+w $filelist_all; \
619 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
620 echo "DONE"; \
621 fi; \
622 if [ -n "$filelist_unneeded" ]; then \
623 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
624 chmod u+w $filelist_unneeded; \
625 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
626 echo "DONE"; \
627 fi; \
628 if [ -n "$filelist_debug" ]; then \
629 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
630 chmod u+w $filelist_debug; \
631 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
632 echo "DONE"; \
633 fi; \
634fi; }; __spec_install_post_strip } } }
635
636#-----------------------------------------------------------------
637# remove all RPATH/RUNPATH from executable binaries and shared object files
638#
639# Requires: find, awk, cut, xargs, chrpath, uname
640#
641# Special macros which affect this process
642#%no_install_post_chrpath 1 # disable chrpath at all
643#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
644#
645%__spec_install_post_chrpath {%{!?debug: \
646%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
647%{!?debug:set +x;} \
648if [ -d "$RPM_BUILD_ROOT" ]; then \
649 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
650 if [ -n "$files" ]; then \
651 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
652 fi; \
653 if [ -n "$objs" ]; then \
654 printf "Remove RPATH/RUNPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
655 echo "$objs" | \
656 while read file; do \
657 rpath= ; \
658 chmod u+w "$file"; \
659 for dir in $(chrpath -l "$file" | awk '/(R|RUN)PATH=/ { gsub(/.*RPATH=/,""); gsub(/.*RUNPATH=/,""); gsub(/:/," "); print $0 }'); do \
660 case $dir in \
661 '$ORIGIN' ) \
662 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
663 else rpath="$rpath:$dir" ; fi ; \
664 continue ; \
665 ;; \
666 esac ; \
667 newdir=$(readlink -m "$dir"); \
668 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
669 case $dir in \
670 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
671 echo "remove-rpath: $dir in $file"; \
672 ;; \
673 * ) \
674 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
675 else rpath="$rpath:$dir" ; fi ; \
676 ;; \
677 esac ; \
678 done ; \
679 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
680 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
681 done; \
682 fi; \
683fi; }; __spec_install_post_chrpath } } }
684
685# vim: "
686
687#-----------------------------------------------------------------
688# Find all shared object files with unresolved symbols. Warn
689# and terminate if any found (termination can be turned off by define).
690#%no_install_post_check_so 1
691#%skip_post_check_so libwithunresolvedok.so.*
692#
693# NOTE: define skip_post_check_so only if such library really requires
694# unresolved symbols and always leave a comment why it is required:
695# # executable provides symbols foo, bar for those libraries:
696# %define skip_post_check_so libwithoutfoo.so.* libwithoutbar.so.*
697#
698%__spec_install_post_check_so { \
699__spec_install_post_check_so() { \
700%{!?debug:set +x;} \
701 fail=0; \
702 printf "Searching for shared objects with unresolved symbols..."; \
703 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
704 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; %{?skip_post_check_so:split("%{skip_post_check_so}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "Library marked with skip_post_check_so, ignoring errors.\n"; exit(0); } } } exit(1); } } ' || fail=1 ; \
705 done ; \
706 echo " DONE"; \
707 %{!?no_install_post_check_so:return $fail;} \
708}; __spec_install_post_check_so }}
709
710#-----------------------------------------------------------------
711# Verify that for each directory under /var/run package contains
712# tmpfiles.d configuration. Warn and terminate build if config is
713# missing.
714#
715#%no_install_post_check_tmpfiles 1
716#
717%__spec_install_post_check_tmpfiles { \
718__spec_install_post_check_tmpfiles() { \
719%{!?debug:set +x;} \
720 fail=0; \
721 echo "Checking /var/run <-> tmpfiles.d completeness..."; \
722 for d in $RPM_BUILD_ROOT/var/run/*; do \
723 [ -d "$d" ] || continue; \
724 d=${d##$RPM_BUILD_ROOT}; \
725 if ! grep -qsF "$d" $RPM_BUILD_ROOT/usr/lib/tmpfiles.d/*.conf $RPM_BUILD_ROOT/etc/tmpfiles.d/*.conf; then\
726 echo "No tmpfiles configuration for '$d'";\
727 fail=1 ; \
728 fi \
729 done ; \
730 echo " DONE"; \
731 %{!?no_install_post_check_tmpfiles:return $fail;} \
732}; __spec_install_post_check_tmpfiles }}
733
734#-----------------------------------------------------------------
735# Find and gzip all kernel modules
736#
737# Requires: find
738#
739#%no_install_post_compress_modules 1
740%__spec_install_post_compress_modules { \
741%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
742%{!?debug:set +x;} \
743 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
744 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
745 if [ "$q" ]; then \
746 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
747 echo "$q" | xargs -r %{__gzip} -9nf; \
748 echo "DONE"; \
749 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
750 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
751 fi; \
752 fi; \
753}; __spec_install_post_compress_modules } }
754
755# Remove common Perl files we don't package
756%__spec_install_post_perl_clean {\
757%{!?no_install_post_perl_clean: \
758%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
759} }
760
761#-----------------------------------------------------------------
762# Update GConf2 schemas
763#
764# Requires: GConf2
765#
766%gconf_schema_install() \
767 umask 022; \
768 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
769 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
770%{nil}
771
772%gconf_schema_uninstall() \
773if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
774 umask 022; \
775 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
776 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
777fi; \
778%{nil}
779
780#-----------------------------------------------------------------
781# Update desktop MIME database
782# requires: desktop-file-utils
783%update_desktop_database() {{ \
784 umask 022; \
785 /usr/bin/update-desktop-database -q; \
786};} \
787%{nil}
788
789%update_desktop_database_post %update_desktop_database
790
791%update_desktop_database_postun() {{ \
792if [ "$1" = "0" ]; then \
793 %update_desktop_database \
794fi; \
795};} \
796%{nil}
797
798#-----------------------------------------------------------------
799# Update shared MIME info database
800# requires: shared-mime-info
801#
802%update_mime_database() {{ \
803 umask 022; \
804 /usr/bin/update-mime-database %{_datadir}/mime; \
805};} \
806%{nil}
807
808#-----------------------------------------------------------------
809# Update icon cache
810# BuildRequires: rpmbuild(macros) >= 1.596
811# Requires: hicolor-icon-theme
812#
813%update_icon_cache() {{ \
814 %{!?1:%{error:%{0}: Required theme name missing}} \
815 if [ -x /usr/bin/gtk-update-icon-cache ]; then \
816 umask 022; \
817 touch --no-create %{_iconsdir}/%1; \
818 /usr/bin/gtk-update-icon-cache -qf %{_iconsdir}/%1; \
819 fi; \
820};} \
821%{nil}
822
823#-----------------------------------------------------------------
824# Update scrollkeeper database
825# requires: scrollkeeper
826#
827%scrollkeeper_update_post() \
828 /usr/bin/scrollkeeper-update -q; \
829%{nil}
830
831%scrollkeeper_update_postun() \
832if [ "$1" = "0" ]; then \
833 /usr/bin/scrollkeeper-update -q; \
834fi; \
835%{nil}
836
837#-----------------------------------------------------------------
838# Compile GSettings schemas
839# requires: glib2 >= 1:2.26.0
840#
841%glib_compile_schemas() {{ \
842 umask 022; \
843 /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas; \
844};} \
845%{nil}
846
847#-----------------------------------------------------------------
848# post %install sequence:
849# - autodeps exceptions
850# - compress all man and info pages,
851# - strip all ELF executables and ELF shared objects if not %debug.
852# - compress kernel modules if any
853
854###################################################################
855# Requires/Provides automation
856# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
857#
858%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
859%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
860%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
861%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
862%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq) \
863 %{?_noautoreq: %{_noautoreq}} \
864 %{?_noautoreq_pear: %{__noauto_regexp_helper -p pear %{_noautoreq_pear}}} \
865 %{?_noautoreq_perl: %{__noauto_regexp_helper -p perl %{_noautoreq_perl}}} \
866 %{?_noautoreq_java: %{__noauto_regexp_helper -p java %{_noautoreq_java}}} \
867 %{nil}
868
869# helper for wrapping _noautoreq between perl() or pear()
870# Author: Elan Ruusamäe <glen@pld-linux.org>
871# Usage:
872# BuildRequires: rpmbuild(macros) >= 1.654
873# %define _noautoreq_pear Excluded.php PEAR/Something.php
874# %define _noautoreq_perl Apache::.*
875# BuildRequires: rpmbuild(macros) >= 1.672
876# %define _noautoreq_java ClassDataVersion
877%__noauto_regexp_helper(p:) %(echo "%*" | awk 'BEGIN{RS=" "}{printf("%{-p*}\\\\\\(%%s\\\\\\) ", $1)}')
878
879#%_noautocompressdoc %{nil}
880#
881%_missing_doc_files_terminate_build 1%{nil}
882%_unpackaged_files_terminate_build %{nil}
883# (X)emacs support
884%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
885%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
886%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
887
888%__php_provides %{nil}
889%__php_requires %{nil}
890%__perl_provides %{nil}
891%__perl_requires %{nil}
892%__mono_provides %{nil}
893%__mono_requires %{nil}
894
895# Perl specific macro definitions.
896%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
897%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
898%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
899%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
900%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
901%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
902
903# Ruby
904%__ruby /usr/bin/ruby
905
906%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
907%ruby_libdir %{expand:%%global ruby_libdir %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_libdir
908%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
909%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
910%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
911%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
912%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
913%ruby_sitedir %{expand:%%global ruby_sitedir %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["sitedir"]' 2>/dev/null || echo ERROR)}%ruby_sitedir
914%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
915%ruby_rdocdir /usr/share/rdoc
916%ruby_vendordir %{expand:%%global ruby_vendordir %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["vendordir"]' 2>/dev/null || echo ERROR)}%ruby_vendordir
917%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
918
919%ruby_gemdir %{expand:%%global ruby_gemdir %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["rubylibdir"].sub(RbConfig::CONFIG["ruby_version"], "gems/#{RbConfig::CONFIG["ruby_version"]}")' 2>/dev/null || echo ERROR)}%{ruby_gemdir}
920%ruby_specdir %{ruby_gemdir}/specifications
921
922# deprecated, similar functionality autogenerated with rpm5
923%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
924%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
925
926%php_pear_dir /usr/share/pear
927%php_data_dir /usr/share/php
928%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
929%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
930%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
931
932# extract php/zend api versions
933%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
934%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
935%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
936%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
937%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
938%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
939%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
940%_zend_zts %{expand:%%global _zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%_zend_zts
941# "_ts" if ZTS enabled, empty otherwise
942%zend_zts %{expand:%%global _zend_zts_%{?_zend_zts} 1}%{?_zend_zts_1:_ts}
943
944# name of php package
945%php_name php%{?php_suffix}
946# use rpmbuild -D 'php_suffix 54' to build php extension for php 5.4
947# NOTE: error output must be empty. otherwise can't build pecl packages if no php*-devel is installed
948%php_suffix %{expand:%%global php_suffix %(c=$(php-config --sysconfdir 2>/dev/null) || echo '' && echo ${c#/etc/php})%%{nil}}%php_suffix
949
950# php cli. version that php headers are installed for
951%__php /usr/bin/%{php_name}
952
953# helper macro
954%__php_api_requires(v:) Requires: %{php_name}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
955
956# macros for public use
957# for php extensions (php-pecl)
958%requires_php_extension %{__php_api_requires modules_api php_api_version} \
959%{__php_api_requires zend_module_api} \
960%{__php_api_requires debug php_debug} \
961%{__php_api_requires thread-safety _zend_zts}
962
963# for zend extensions
964%requires_zend_extension %{__php_api_requires zend_module_api} \
965%{__php_api_requires zend_extension_api} \
966%{__php_api_requires debug php_debug} \
967%{__php_api_requires thread-safety _zend_zts}
968
969# for php pdo modules (php-pecl-PDO_*)
970%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
971
972# for using PHP post scripts. for PHP >= 5.0
973%php_webserver_restart \
974[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
975[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
976if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
977 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
978 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
979 %service -q php-fcgi restart \
980 fi \
981fi \
982if [ -x /etc/rc.d/init.d/%{php_name}-fpm ]; then \
983 %service -q %{php_name}-fpm restart \
984fi \
985%{nil}
986
987# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
988%php4_webserver_restart \
989[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
990[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
991if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
992 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
993 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
994 %service -q php-fcgi restart \
995 fi \
996fi \
997%{nil}
998
999# X.org helper macros
1000%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
1001%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
1002
1003%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
1004%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
1005%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
1006%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
1007%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
1008# vim: '
1009
1010%requires_xorg_xserver_extension \
1011%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1012%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1013%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
1014%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
1015%{nil}
1016
1017%requires_xorg_xserver_xinput \
1018%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1019%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1020%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
1021%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
1022%{nil}
1023
1024%requires_xorg_xserver_font \
1025%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1026%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1027%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
1028%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
1029%{nil}
1030
1031%requires_xorg_xserver_videodrv \
1032%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1033%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1034%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
1035%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
1036%{nil}
1037
1038# TCL specific macro definitions.
1039# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
1040%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
1041%tcl_sitearch %{_libdir}/tcl%{tcl_version}
1042%tcl_sitelib %{_datadir}/tcl%{tcl_version}
1043
1044# Python specific macro definitions.
1045# python main version
1046%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
1047
1048# directories
1049%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
1050%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
1051%py_scriptdir %{py_prefix}/share/python%{py_ver}
1052%py_incdir /usr/include/python%{py_ver}
1053%py_sitedir %{py_libdir}/site-packages
1054%py_sitescriptdir %{py_scriptdir}/site-packages
1055%py_dyndir %{py_libdir}/lib-dynload
1056
1057# pure python modules compilation
1058%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1059
1060%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1061
1062# Software written in Python language require Python with main version
1063%pyrequires_eq() Requires: %1
1064
1065# Python 3.x
1066# python main version
1067%__python3 python3
1068%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
1069
1070# directories
1071%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
1072%py3_libdir %{expand:%%global py3_libdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('platstdlib'))" 2>/dev/null || echo ERROR)}%py3_libdir
1073%py3_incdir %{expand:%%global py3_incdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('include'))" 2>/dev/null || echo ERROR)}%py3_incdir
1074%py3_sitedir %{expand:%%global py3_sitedir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('platlib'))" 2>/dev/null || echo ERROR)}%py3_sitedir
1075%py3_sitescriptdir %{expand:%%global py3_sitescriptdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('purelib'))" 2>/dev/null || echo ERROR)}%py3_sitescriptdir
1076%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
1077%py3_dyndir %{py3_libdir}/lib-dynload
1078
1079# pure python modules compilation
1080%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1081
1082%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1083
1084# node.js libdir
1085# Requirements:
1086# BuildRequires: rpmbuild(macros) >= 1.634
1087%nodejs_libdir /usr/lib/node_modules
1088
1089# bash-completion 2.0 completions dir
1090# Requirements:
1091# BuildRequires: rpmbuild(macros) >= 1.673
1092# Requires: bash-completion >= 2.0
1093%bash_compdir /usr/share/bash-completion/completions
1094
1095# Hardlink binary identical .pyc and .pyo files
1096%__spec_install_post_py_hardlink {\
1097%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
1098%{!?debug:set +x;} \
1099local a b c=0 t=0 pyc=%{tmpdir}/%{name}-%{version}-%{release}__rpm_pyc; \
1100if [ -d "$RPM_BUILD_ROOT" ]; then \
1101 find "$RPM_BUILD_ROOT" -name '*.pyc' > $pyc; \
1102 while read a; do \
1103 b="${a%.pyc}.pyo"; \
1104 if cmp -s "$a" "$b"; then \
1105 ln -f "$a" "$b"; \
1106 c=$((c + 1)); \
1107 fi; \
1108 t=$((t + 1)); \
1109 done < $pyc; \
1110 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
1111 rm -f $pyc; \
1112fi; \
1113}; __spec_install_post_py_hardlink } }
1114
1115# Remove Python 2.x sources,
1116# PLD Linux policy is to package only compiled .py[co] for Python 2.x libraries.
1117# Author: Elan Ruusamäe <glen@pld-linux.org>
1118#
1119# Usage:
1120# %py_postclean /usr/share/extra -x keepme.py,keeptoo.py
1121# Options:
1122# -x - comma separated of file basenames to preserve
1123# ARGS - extra directories to clean for .py sources
1124#
1125%py_postclean(x:) \
1126for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
1127 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 %{-x:| grep -ZzvE '/(%(echo '%{-x*}' | tr ',' '|'))$'} | xargs -0r -l512 rm;\
1128done \
1129%{nil}
1130
1131# depmod macro
1132%depmod() { \
1133umask 022; \
1134if [ -e /boot/System.map-%1 ]; then \
1135 /sbin/depmod -a -F /boot/System.map-%1 %1; \
1136else \
1137 if [ -e /boot/System.map ]; then \
1138 /sbin/depmod -a -F /boot/System.map %1; \
1139 else \
1140 /sbin/depmod -a %1; \
1141 fi \
1142fi; \
1143}
1144
1145# XMMS specific macros
1146%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
1147%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
1148%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
1149%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
1150%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
1151%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
1152%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1153%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1154%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1155%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1156
1157%_host_base_arch %{expand:%%global _host_base_arch %(echo %{_host_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/;s/arm.*/arm/')}%_host_base_arch
1158%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/;s/arm.*/arm/')}%_target_base_arch
1159
1160# user/group checking macros
1161#
1162# Usage:
1163# %userremove myuser
1164#
1165%userremove /usr/lib/rpm/user_group.sh user del
1166%groupremove /usr/lib/rpm/user_group.sh group del
1167#
1168# Usage:
1169# if %usertestrm myuser; then
1170# /usr/sbin/userdel -r myuser
1171# Note:
1172# use these macros only if you need to call userdel/groupdel with
1173# a non-standard option or take an extra action; otherwise use the
1174# %userremove/%groupremove macros
1175#
1176%usertestrm /usr/lib/rpm/user_group.sh user testrm
1177%grouptestrm /usr/lib/rpm/user_group.sh group testrm
1178# user group membership management macros
1179#
1180# Usage:
1181# %addusertogroup [-q] myuser agroup
1182#
1183# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1184#
1185# Requirements:
1186# BuildRequires: rpmbuild(macros) >= 1.515
1187%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1188%{nil}
1189
1190# banner support (useful in {pre,post}{,un} and triggers)
1191#
1192# Usage:
1193# %banner name [-a] [-e] [-n] [-tn] [-o] <<EOF
1194# the banner text, the banner text
1195# the banner text, and following line
1196#EOF
1197# You can use any form of here-document, <<'EOF' <<-EOT will do.
1198# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1199#
1200# -a - append to the banner
1201# -e - send to stderr instead of stdout
1202# -n - no show banner (overrides -t)
1203# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
1204# -o - show only once, i.e when package is installed for the first time
1205#
1206# Tests:
1207# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1208# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1209# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m 1
1210# rpm -E 'date | %banner -e banner' > m; sh -x m
1211# rpm -E 'date | %banner -o -e banner' > m; sh -x m
1212#
1213%banner(aenot:) %{-o:([ "$1" != 1 ] ||} ( \
1214RPM_SCRIPTVERBOSITY=5 \
1215[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1216if [ -x /usr/bin/banner.sh ]; then \
1217 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1218else \
1219 CMD="cat%{-e: >&2}" \
1220fi \
1221eval $CMD %{?2:%2}%{?3: %3})%{-o:)} \
1222%{nil}
1223
1224# useradd/groupadd macros
1225# Author: Elan Ruusamäe <glen@pld-linux.org>
1226#
1227# Usage:
1228# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1229# [-g initial_group] [-G group[,...]] login
1230#
1231# -u uid. REQUIRED
1232# -g gid/group. REQUIRED
1233# -s defaults to /bin/false
1234# -d defaults to /usr/share/empty
1235# -c No default
1236# -r is accepted but ignored (it's always set)
1237# -k skeleton dir. defaults to /usr/share/empty
1238# rpm specific flags
1239# -P package name. defaults to %{name}
1240#
1241%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
1242%{!-u:%{error:useradd: Required argument -u missing}} \
1243%{!-g:%{error:useradd: Required argument -g missing}} \
1244%{!?1:%{error:useradd: Required parameter login missing}} \
1245if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1246 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1247 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1248 exit 1 \
1249 fi \
1250else \
1251 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1252 /usr/sbin/useradd \\\
1253 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
1254 -u %{-u*} \\\
1255 -r \\\
1256 -d %{-d*}%{!-d:/usr/share/empty} \\\
1257 -s %{-s*}%{!-s:/bin/false} \\\
1258 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
1259 -g %{-g*} \\\
1260 %{-M} \\\
1261 %{-G:-G %{-G*}} \\\
1262 %{expand:%{%{#}}} 1>&2 || exit $? \
1263 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
1264fi;
1265# vim: "
1266
1267# Usage:
1268# %groupadd [-P package] [-g gid] group
1269#
1270# -g gid. REQUIRED
1271#
1272# Sample:
1273# %groupadd -P %{name}-base -g %{gid} %{name}
1274
1275%groupadd(g:P:rfo) \
1276%{!-g:%{error:groupadd: Required argument -g missing}} \
1277%{!?1:%{error:groupadd: Required parameter group missing}} \
1278if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1279 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1280 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1281 exit 1 \
1282 fi \
1283else \
1284 echo "Adding group %{1} GID=%{-g*}." \
1285 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1286 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1287fi;
1288
1289# webapp macros
1290# Author: Elan Ruusamäe <glen@pld-linux.org>
1291#
1292# The config is installed/removed inside trigger, this means that you can any
1293# time install apache1/apache/lighttpd package and the configuration file is
1294# updated. if you don't need the config for various reason for specific
1295# webserver, just remove the symlink from config directory using webapp
1296# program. the trigger will not recreate the symlink on upgrades. In other
1297# words the config is linked to webserver config directory on first install of
1298# PACKAGE or WEBSERVER.
1299#
1300# Add package's webserver config to webserver webapps dir.
1301# Usage:
1302# %webapp_register [-f] WEBSERVER WEBAPP
1303#
1304%webapp_register(f) \
1305%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1306if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1307 /usr/sbin/webapp register %1 %2\
1308fi\
1309# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
1310if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
1311 %{expand:%service -q %%1 reload}\
1312fi\
1313%{nil}
1314
1315# Remove package's config from webserver webapps dir.
1316# Usage:
1317# %webapp_register [-f] WEBSERVER WEBAPP
1318%webapp_unregister(f) \
1319%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1320# remove link if either of the packages are gone \
1321if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
1322 /usr/sbin/webapp unregister %1 %2\
1323 %{expand:%service -q %%1 reload}\
1324fi \
1325%{nil}
1326
1327# service macro.
1328# Author: Elan Ruusamäe <glen@pld-linux.org>
1329#
1330# calls usual service restart on package %post, but skips the restart if
1331# administrator has disabled automatic service restarts in either global
1332# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1333#
1334# Usage:
1335# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1336#
1337# -q be silent when service isn't started (for scriplets restaring other package's services)
1338# -n NOOP mode, do not actually restart service
1339#
1340# Requirements:
1341# BuildRequires: rpmbuild(macros) >= 1.268
1342# Requires: rc-scripts
1343# -n option:
1344# BuildRequires: rpmbuild(macros) >= 1.450
1345%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1} RPM_BUILD_ROOT=%{buildroot}; /usr/lib/rpm/service_generator.sh %{*}) };}
1346
1347# Java macros. based on jpackage macros.java
1348#
1349# Root directory where all Java VMs/SDK/JREs are installed.
1350%_jvmdir %{_libdir}/jvm
1351
1352# Root directory where all Java VMs/SDK/JREs expose their jars
1353%_jvmjardir %{_libdir}/jvm-exports
1354
1355# Root directory for all Java VM/SDK/JRE's private things.
1356%_jvmprivdir %{_libdir}/jvm-private
1357
1358# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1359%_jvmlibdir %{_libdir}/jvm
1360
1361# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1362%_jvmdatadir %{_datadir}/jvm
1363
1364# Root directory for all configurations parts of Java VM/SDK/JRE's
1365%_jvmsysconfdir %{_sysconfdir}/jvm
1366
1367# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1368%_jvmcommonlibdir %{_libdir}/jvm-common
1369
1370# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1371%_jvmcommondatadir %{_datadir}/jvm-common
1372
1373# Root directory for all common configurations parts of Java VM/SDK/JRE's
1374%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
1375
1376# Directory where arch-specific (JNI) version-independent jars are installed.
1377%_jnidir %{_libdir}/java
1378
1379
1380# JDK selection. Set this to name of the JDK implementation to use
1381# insead of the system default
1382#%use_jdk icedtea6
1383
1384# expands to the value with right jdk for BuildRequires header
1385# 'jdk' if %%use_jdk is not defined, jdk(%%use_jdk) otherwise
1386# The requirement will not replace current 'default' JDK
1387%required_jdk jdk%{?use_jdk:(%{use_jdk})}
1388
1389%buildrequires_jdk BuildRequires: %required_jdk
1390
1391%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm}%{?use_jdk:JAVA_HOME=%{_jvmdir}/%{use_jdk}}; echo ${JAVA_HOME:-ERROR})}%java_home
1392
1393%_javasrcdir %{_usrsrc}/java
1394
1395%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
1396%jar %{java_home}/bin/jar
1397%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd}%{?use_jdk:JAVACMD=%{java_home}/bin/java}; echo $JAVACMD)}%java
1398%javac %{java_home}/bin/javac
1399%javadoc %{java_home}/bin/javadoc
1400
1401%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
1402
1403%jpackage_script() \
1404install -d $RPM_BUILD_ROOT%{_bindir}\
1405cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1406#!/bin/sh\
1407#\
1408# %{name} script\
1409# JPackage Project <http://www.jpackage.org/>\
1410\
1411# Source functions library\
1412. %{_javadir}-utils/java-functions\
1413\
1414# Source system prefs\
1415if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1416 . %{_sysconfdir}/java/%{name}.conf\
1417fi\
1418\
1419# Source user prefs\
1420if [ -f $HOME/.%{name}rc ]; then\
1421 . $HOME/.%{name}rc\
1422fi\
1423\
1424# Configuration\
1425MAIN_CLASS=%1\
1426BASE_FLAGS=%2\
1427BASE_OPTIONS=%3\
1428BASE_JARS="%(echo %4 | tr ':' ' ')"\
1429\
1430# Set parameters\
1431set_jvm\
1432set_classpath $BASE_JARS\
1433set_flags $BASE_FLAGS\
1434set_options $BASE_OPTIONS\
1435\
1436# Let's start\
1437run "$@"\
1438EOF
1439
1440# jpackage 1.7
1441# Directory for maven depmaps
1442#
1443%_mavendepmapdir /etc/maven
1444%_mavendepmapfragdir /etc/maven/fragments
1445
1446#
1447# add_to_depmap adds an entry to the depmap. The arguments are:
1448#
1449# %1 the original groupid
1450# %2 the original artifact id
1451# %3 the version
1452# %4 the new groupid
1453# %5 the new artifactid
1454#
1455
1456%add_to_maven_depmap() \
1457install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1458cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1459<dependency>\
1460 <maven>\
1461 <groupId>%1</groupId>\
1462 <artifactId>%2</artifactId>\
1463 <version>%3</version>\
1464 </maven>\
1465 <jpp>\
1466 <groupId>%4</groupId>\
1467 <artifactId>%5</artifactId>\
1468 <version>%3</version>\
1469 </jpp>\
1470</dependency>\
1471\
1472EOF\
1473%{nil}
1474
1475#==============================================================================
1476#
1477# update_maven_depmap updates the main maven depmap
1478#
1479%update_maven_depmap() \
1480echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1481if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1482cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1483fi\
1484echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1485
1486# JAVA macros specific for PLD
1487
1488# Directory for tomcat context configuration files
1489%_tomcatconfdir %{_sharedstatedir}/tomcat/conf/Catalina/localhost
1490
1491# Tomcat cache path
1492%_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1493
1494# Clear tomcat cache
1495# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1496#
1497# Usage:
1498# %%tomcat_clear_cache appname
1499#
1500# Call this script in %postun scriptlet. It will remove compiled jsps related to
1501# given app.
1502#
1503%tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1504
1505# PEAR install macros
1506# Author: Elan Ruusamäe <glen@pld-linux.org>
1507#
1508# Usage:
1509# %%pear_package_setup ...
1510#
1511# -a # - also unpack SOURCE#. for PEAR bootstrapping
1512# -n FMT - create builddir with FMT, instead of default %%{pearname}-%%{version}
1513# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1514# -D - pass -D to %setup (so the build dir is not removed)
1515# -c - register channel from local channel.xml file
1516# -d - pass -d arg to pearcmd
1517#
1518# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1519# destination hierarchy. you should copy the tree to buildroot after
1520# patching/reorganizing with %%pear_package_install.
1521#
1522# additionally BUILDROOT is stripped from files and files are converted to UNIX
1523# line endings.
1524#
1525# the pear install process output is recorded to install.log, you should put it
1526# to %%doc for later debug or just for information.
1527#
1528# additionally additional-packages.txt is produced if it was detected that the
1529# package has optional dependencies. the file format is suitable of displaying
1530# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1531# automatically added for this file.
1532
1533
1534# records install.log and transforms PEAR names to PLD Linux rpm package names.
1535%__pear_install_log \
1536tee install.log \
1537# make post message of optional packages \
1538grep -E 'can optionally use|Optional feature' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,' > optional-packages.txt \
1539if [ -s optional-packages.txt ]; then \
1540 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1541else \
1542 rm -f optional-packages.txt \
1543fi \
1544%{nil}
1545
1546# Command invoking PEAR CLI
1547# Same as /usr/bin/pear, except we force GMT timezone
1548%__pear %__php -doutput_buffering=1 -dopen_basedir="" -dmemory_limit=-1 -ddate.timezone=GMT /usr/share/pear/pearcmd.php
1549
1550%pear_install(a:d:n:zD) \
1551%__pear \\\
1552 -c %{builddir}/pearrc \\\
1553 -d doc_dir=/docs \\\
1554 -d temp_dir=/tmp \\\
1555 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
1556 -d bin_dir=%{_bindir} \\\
1557 -d data_dir=%{php_pear_dir}/data \\\
1558 -d test_dir=%{php_pear_dir}/tests \\\
1559 %{-d:%(echo "%{-d*}" | awk 'BEGIN{RS=","}{printf("-d %%s \\\\\\n\\t", $1)}')} \\\
1560 install \\\
1561 --packagingroot=%{builddir} \\\
1562 --offline \\\
1563 --nodeps \\\
1564 %{-f:--force} \\\
1565 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1566 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
1567%{nil}
1568
1569# The main macro.
1570# using this macro will append optional-packages.txt to the nocompressdoc list
1571# as it's displayed to user after package install. and adding additional gzip
1572# dep is just waste ;)
1573%pear_package_setup(a:d:n:zDc:) \
1574%define srcdir %{-n*}%{!-n:%{?_pearname}%{!?_pearname:%{pearname}}-%{version}} \
1575%define builddir %{_builddir}/%{srcdir} \
1576%setup -q -c -T %{-D:-D} -n %{srcdir} \
1577%{-z:%{__tar} zxf %{S:0}; %{-a:%{__tar} zxf %{S:%{-a*}}}} \
1578%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1579%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
1580%pear_install \
1581%{-z:cd ..} \
1582%{__tar} --wildcards -zvxf %{S:0} package*.xml \
1583cat %{-z:$_N/}.install.log | %__pear_install_log \
1584%undos -f php,html,js,xml \
1585%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1586%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1587%{nil}
1588
1589# Copies extracted PEAR package structure and PEAR registry to buildroot.
1590# Author: Elan Ruusamäe <glen@pld-linux.org>
1591%pear_package_install() \
1592cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1593# tests should not be packaged \
1594%{__rm} -rf $RPM_BUILD_ROOT%{php_pear_dir}/tests \
1595# cleanup backups \
1596find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1597# help the developer out a little: \
1598if [ -f _noautoreq ]; then \
1599 echo "AutoReqdep detected:" \
1600 echo "_noautoreq $(cat _noautoreq)" \
1601fi \
1602%{nil}
1603
1604# Print optional package info for pear packages
1605# Author: Elan Ruusamäe <glen@pld-linux.org>
1606# Usage:
1607# %post -p <lua>
1608# %%pear_package_print_optionalpackages
1609#
1610# Requirements:
1611# BuildRequires: rpmbuild(macros) >= 1.571
1612%pear_package_print_optionalpackages \
1613f = io.open("%{_docdir}/%{name}-%{version}/optional-packages.txt", "r") \
1614if f then \
1615 for l in f:lines() do print(l); end \
1616 f:close() \
1617end \
1618%{nil}
1619
1620
1621# Register OpenLDAP schema.
1622# Author: Elan Ruusamäe <glen@pld-linux.org>
1623#
1624# Usage:
1625# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1626#
1627# -d specify dependant schemas, separated by comma
1628#
1629%openldap_schema_register(d:) \
1630for schema in %*; do \
1631 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1632 %{__sed} -i -e " \
1633 /^include.*local.schema/{ \
1634 iinclude\\t $schema\
1635 } \
1636 " /etc/openldap/slapd.conf \
1637 fi \
1638done \
1639# enable dependant schemas \
1640if [ "%{-d*}" ]; then \
1641 %{__sed} -i -e ' \
1642 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1643 s/^#// \
1644 }' /etc/openldap/slapd.conf \
1645fi \
1646%{nil}
1647
1648# Unregister OpenLDAP schema.
1649# Author: Elan Ruusamäe <glen@pld-linux.org>
1650#
1651# Usage:
1652# %%openldap_schema_unregister %{schemadir}/horde.schema
1653#
1654%openldap_schema_unregister() \
1655for schema in %*; do \
1656 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1657 %{__sed} -i -e " \
1658 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1659 # for symmetry it would be nice if we disable enabled schemas in post, \
1660 # but we really can not do that, it would break something else. \
1661 " /etc/openldap/slapd.conf \
1662 fi \
1663done \
1664%{nil}
1665
1666%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1667
1668
1669# Build modules for kernels 2.6
1670# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1671#
1672# Usage:
1673# %build_kernel_modules -m <modules> -C <directory>
1674#
1675# remember that proper Makefile is still required
1676# Options:
1677# -m <modules> (required) -- comma-separated list of modules to save,
1678# without .ko extension, may be placed in subdirectory
1679# -C <directory> -- change to <directory> before doing anything
1680# -p <arg>, -P <arg> -- arguments passeed to make scripts
1681# -c -- do not execute make clean
1682# <additional arguments> -- all additional arguments will be passed to
1683# make modules
1684#
1685# Additional patching supported via here document. Try:
1686# %build_kernel_modules -m module <<'EOF'
1687# your patch script here
1688# EOF
1689# Don't use it unless patching depends on config options.
1690
1691# Developer note: don't touch it unless you know how to handle '\'.
1692# - \ in script expands to nothing
1693# - \\\ in script expands to \
1694# - \\\ inside definition expands to nothing
1695# - \\\\\\\ inside definition expands to \
1696# - in last line \ has to touch arguments so arguments passing
1697# in new lines (using \) will be supported
1698
1699%build_kernel_modules(p:P:m:C:c) \
1700%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1701 \
1702%define Opts \\\\\\\
1703%if "%{_target_base_arch}" != "%{_host_base_arch}" \\\
1704 %if "%{_host_base_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
1705 CC="%{__cc}" ARCH=%{_target_base_arch} \\\
1706 %else \\\
1707 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1708 %endif \\\
1709%else \\\
1710 CC="%{__cc}" \\\
1711%endif \
1712%define MakeOpts HOSTCC="%{__cc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1713 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1714 \
1715%{?-C:cd %{-C*}} \
1716compile() { \
1717 local L="<" PATCH_SH; \
1718 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1719 set -e -x \
1720 \
1721 [ -r "%{_kernelsrcdir}/.config" ] || exit 1 \
1722 rm -rf o \
1723 install -d o/include/linux o/include/generated o/arch/x86/include o/arch/powerpc/lib \
1724 ln -sf %{_kernelsrcdir}/.config o/.config \
1725 ln -sf %{_kernelsrcdir}/Module.symvers o/Module.symvers \
1726 if [ -f %{_kernelsrcdir}/include/generated/autoconf.h ]; then \
1727 ln -sf %{_kernelsrcdir}/include/generated/autoconf.h o/include/generated/autoconf.h \
1728 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
1729 else \
1730 ln -sf %{_kernelsrcdir}/include/linux/autoconf.h o/include/linux/autoconf.h \
1731 fi \
1732 if [ -d %{_kernelsrcdir}/arch/x86/include/generated ]; then \
1733 ln -s %{_kernelsrcdir}/arch/x86/include/generated o/arch/x86/include \
1734 fi \
1735 \
1736 set +x \
1737 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1738 set -x \
1739 \
1740 install -d o/include/config \
1741 touch o/include/config/MARKER \
1742 ln -sf %{_kernelsrcdir}/include/config/auto.conf o/include/config/auto.conf \
1743 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1744 \
1745 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
1746 RCS_FIND_IGNORE="-name '*.[ks]o' -o" \\\
1747 ${1+"$@"} \\\
1748 M=$PWD %{MakeOpts}} \
1749 \
1750 %{__make} -C %{_kernelsrcdir} modules \\\
1751 ${1+"$@"} \\\
1752 M=$PWD CONSTIFY_PLUGIN="" %{MakeOpts} \
1753%{?-C:cd -} \
1754} \
1755compile_old() { \
1756 local L="<" PATCH_SH; \
1757 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1758 set -e -x \
1759 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1760 \
1761for cfg in ${cfgs:-dist}; do \
1762 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1763 \
1764 rm -rf o \
1765 install -d o/include/linux o/include/generated o/arch/powerpc/lib \
1766 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1767 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1768 if [ -f %{_kernelsrcdir}/include/generated/autoconf-$cfg.h ]; then \
1769 ln -sf %{_kernelsrcdir}/include/generated/autoconf-$cfg.h o/include/generated/autoconf.h \
1770 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
1771 else \
1772 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1773 fi \
1774 \
1775 set +x \
1776 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1777 set -x \
1778 \
1779 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
1780 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1781 %{-p*} %{-P*} \\\
1782 %{MakeOpts} \
1783 %else \
1784 install -d o/include/config \
1785 touch o/include/config/MARKER \
1786 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
1787 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1788 %endif \
1789 \
1790 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
1791 RCS_FIND_IGNORE="-name '*.[ks]o' -o" \\\
1792 ${1+"$@"} \\\
1793 M=$PWD %{MakeOpts}} \
1794 \
1795 %{__make} -C %{_kernelsrcdir} modules \\\
1796 ${1+"$@"} \\\
1797 M=$PWD CONSTIFY_PLUGIN="" %{MakeOpts} \
1798 \
1799 for MODULE in {%{-m*},}; do \
1800 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1801 done \
1802done \
1803%{?-C:cd -} \
1804} \
1805if [ -r "%{_kernelsrcdir}/.config" ]; then \
1806 compile %{*} \
1807else \
1808 compile_old %{*} \
1809fi \
1810%{nil}
1811
1812
1813# Install kernel modules built by %build_kernel_modules
1814# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1815#
1816# Usage:
1817# %install_kernel_modules -m <modules> -d <directory>
1818#
1819# Options:
1820# -m <modules> (required) -- comma-separated list of modules to install,
1821# without .ko extension, may be placed in subdirectory
1822# -d <directory> (required) -- in what subdirectory modules should be
1823# installed (eg. misc, kernel/drivers/net)
1824# -s <suffix> -- suffix to use when installing modules, useful when module
1825# with same name exists in kernel already
1826# -n <file> -- name of modprobe config file to use (without .conf extension)
1827# for defining aliases, only useful with -s
1828
1829%install_kernel_modules(m:d:s:n:) \
1830%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1831%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1832%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1833 \
1834%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1835%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1836 \
1837__install_kernel_modules() { \
1838%{!?debug:set +x;} \
1839 \
1840for MODULE in {%{-m*},}; do \
1841 [ -n "${MODULE}" ] || continue \
1842 MNAME=${MODULE##*/} \
1843 install -m 644 -D ${MODULE}.ko %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
1844 %{?-s:install -d %{ModprobeD} \
1845 echo "alias ${MNAME} ${MNAME}-%{-s*}" >> %{ModprobeD}/%{-n*}.conf} \
1846done \
1847} \
1848__install_kernel_modules_old() { \
1849%{!?debug:set +x;} \
1850local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1851 \
1852for MODULE in {%{-m*},}; do \
1853 [ -n "${MODULE}" ] || continue \
1854 for cfg in ${cfgs:-dist}; do \
1855 [ "$cfg" = smp ] && suf=smp || suf= \
1856 MNAME=${MODULE##*/} \
1857 install -m 644 -D ${MODULE}-$cfg.ko \\\
1858 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
1859 %{?-s:install -d %{ModprobeD}$suf \
1860 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1861 >> %{ModprobeD}$suf/%{-n*}.conf} \
1862 done \
1863done \
1864} \
1865if [ -r "%{_kernelsrcdir}/.config" ]; then \
1866 __install_kernel_modules \
1867else \
1868 __install_kernel_modules_old \
1869fi \
1870%{nil}
1871
1872# patchset macros
1873# Author: Elan Ruusamäe <glen@pld-linux.org>
1874#
1875# Usage:
1876# %patchset_source -f <seq(1) format> <start> [<end>]
1877# %patchset_patch <start> [<end>]
1878#
1879# If <end> is omited, it is assumed to be <start>.
1880#
1881# For example in preamble:
1882# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1883# and in %prep:
1884# %patchset_patch 33 44
1885
1886# generate SourceX urls from range START STOP
1887# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1888# The sources start from 10000
1889%patchset_source(f:b:) %(
1890 base=%{-b*}%{!-b*:10000};
1891 start=$(expr $base + %1);
1892 end=$(expr $base + %{?2}%{!?2:%{1}});
1893 # we need to call seq twice as it doesn't allow two formats
1894 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1895 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1896 paste %{tmpdir}/__ps{1,2};
1897 rm -f %{tmpdir}/__ps{1,2};
1898) \
1899%{nil}
1900
1901# apply sources from %patchset_source
1902# -p specify -pX for %patch line
1903# -b base offset: defaults to 10000
1904%patchset_patch(f:p:b:) %(
1905 base=%{-b*}%{!-b*:10000};
1906 start=$(expr $base + %1);
1907 end=$(expr $base + %{?2}%{!?2:%{1}});
1908 echo ": patchset_patch %1%{?2: to %2}";
1909 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1910) \
1911%{nil}
1912
1913# return EXPANDED source url N from current spec
1914%sourceurl(n:) %(test "$IN_RPM" = 1 && exit 1; export IN_RPM=1; rpmbuild --nodigest --nosignature --nobuild -D "prep %%dump" %{_specdir}/%{name}.spec 2>&1 | awk '$2 ~ /^SOURCEURL%{-n*}/ {print $3}')
1915
1916# browser plugins v2
1917# Author: Elan Ruusamäe <glen@pld-linux.org>
1918#
1919# Usage:
1920# %browser_plugins_add_browser <name> -p <plugindir>
1921#
1922# <name> (required) -- name of the browser. usually %{name}.
1923# -p <plugindir> (required) -- in what directory browser searches for its plugins.
1924# -b -- default blacklists
1925# -a <arch> override arch
1926#
1927# Example:
1928# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1929
1930%_browserpluginsconfdir /etc/browser-plugins
1931%_browserpluginsdir %{_libdir}/browser-plugins
1932%update_browser_plugins /usr/sbin/update-browser-plugins || :
1933
1934%browser_plugins_add_browser(p:b:a:) \
1935 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1936 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1937 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1938 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1939 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1940 %{-b:cat >> $blacklist_file %{-b*}} \
1941%{nil}
1942
1943# Helper for LUA.
1944# split string separated by space into quoted list
1945#
1946# Author: Elan Ruusamäe <glen@pld-linux.org>
1947#
1948# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1949%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1950
1951# adjust /etc/shells by adding and removing shells from there
1952# Author: Elan Ruusamäe <glen@pld-linux.org>
1953#
1954# Usage:
1955# %post -p <lua>
1956# %lua_add_etc_shells /bin/sh /bin/pdksh
1957#
1958# %preun -p <lua>
1959# if arg[2] == 0 then
1960# %lua_remove_etc_shells /bin/bash /bin/rbash
1961# end
1962#
1963# Requirements:
1964# BuildRequires: rpmbuild(macros) >= 1.462
1965#
1966
1967%lua_add_etc_shells() \
1968t = {}\
1969f = io.open("/etc/shells", "r")\
1970if f then\
1971 for l in f:lines() do t[l]=l; end\
1972 f:close()\
1973end\
1974for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1975 if not t[s] then\
1976 print("Adding "..s.." to /etc/shells")\
1977 f = io.open("/etc/shells", "a")\
1978 if f then\
1979 f:write(s.."\\n")\
1980 f:close()\
1981 end\
1982 end\
1983end\
1984%{nil}
1985
1986%lua_remove_etc_shells() \
1987t = {}\
1988f = io.open("/etc/shells", "r")\
1989if f then\
1990 for l in f:lines() do t[l]=l; end\
1991 f:close()\
1992end\
1993for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1994 print("Removing "..l.." from /etc/shells")\
1995 t[l] = nil\
1996end\
1997s=""\
1998for _, l in pairs(t) do\
1999 s=s..l.."\\n"\
2000end\
2001f = io.open("/etc/shells", "w")\
2002if f then\
2003 f:write(s)\
2004 f:close()\
2005end\
2006%{nil}
2007
2008# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
2009#
2010# Author: Elan Ruusamäe <glen@pld-linux.org>
2011#
2012# Usage:
2013# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
2014# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
2015#
2016# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
2017#
2018# Requirements:
2019# BuildRequires: rpmbuild(macros) >= 1.429
2020#
2021%add_etc_shells(p) %{-p:<lua>}\
2022%{expand:%%lua_add_etc_shells %*}\
2023%{nil}
2024
2025%remove_etc_shells(p) %{-p:<lua>}\
2026%{-p:if arg[2] == 0 then}\
2027%{expand:%%lua_remove_etc_shells %*}\
2028%{-p:end} \
2029%{nil}
2030
2031# Check syntax for Python files
2032#
2033# Author: Elan Ruusamäe <glen@pld-linux.org>
2034# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
2035#
2036# Usage:
2037# %py_lint src
2038#
2039# Requirements:
2040# BuildRequires: python
2041# BuildRequires: rpmbuild(macros) >= 1.602
2042
2043%py_lint() \
2044__py_lint() { \
2045%{!?debug:set +x;} \
2046find "$@" -type f -name '*.py' | python -c ' \
2047import sys \
2048import compiler \
2049\
2050found = err = 0\
2051for f in sys.stdin: \
2052 fd = open(f.rstrip()) \
2053 c = fd.read() \
2054 fd.close() \
2055 found = found + 1 \
2056 try: \
2057 compiler.parse(c) \
2058 except SyntaxError, e: \
2059 print "py_lint: %s: %s" % (f.rstrip(), e) \
2060 err = err + 1\
2061\
2062if not found:\
2063 print >> sys.stderr, "\\npy_lint: ERROR: No files processed.\\n" \
2064 sys.exit(1) \
2065elif err: \
2066 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
2067 sys.exit(1) \
2068else: \
2069 print >> sys.stderr, "py_lint: %d files scanned, found no syntax errors." % found \
2070' \
2071}; __py_lint %* \
2072%{nil}
2073
2074# Undos files
2075#
2076# Author: Paweł Zuzelski <pawelz@pld-linux.org>
2077# Author: Elan Ruusamäe <glen@pld-linux.org>
2078#
2079# Usage:
2080# %undos list_of_files
2081# %undos -f EXT[,EXT]
2082# %undos -i -f EXT[,EXT]
2083#
2084# -f EXT[,EXT] - find(1) files by extensions
2085# -i - case insensitive file search
2086#
2087# Example:
2088# Un-DOS all *.js, *.css files
2089# %undos -f js,css
2090# Un-DOS all *.js, *.JS files
2091# %undos -f js -i
2092# undos all Makefiles
2093# %{__find} -name Makefile | xargs %undos
2094#
2095# Requirements:
2096# BuildRequires: sed >= 4.0
2097# BuildRequires: rpmbuild(macros) >= 1.674
2098
2099# NB: make sure this macro stays on one line
2100# NB: make sure it includes newline escape
2101%undos(f:i) %{-f:%{__find} -type f -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
2102%{nil}
2103
2104# Hook to register nagios object based plugins in Nagios NRPE daemon config.
2105#
2106# Author: Elan Ruusamäe <glen@pld-linux.org>
2107#
2108# Usage:
2109# -a NAME -- add command named NAME
2110# -d NAME -- remove command named NAME
2111# -f FILE -- specify plugin configuration FILE to extract command definition from
2112#
2113# Sample:
2114# %triggerin -- nagios-nrpe
2115# %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
2116#
2117# %triggerun -- nagios-nrpe
2118# %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
2119#
2120# Requirements:
2121# Requires: grep
2122# Requires: sed >= 4.0
2123# BuildRequires: rpmbuild(macros) >= 1.552
2124%nagios_nrpe(a:d:c:f:) {\
2125 m=$(md5sum < /etc/nagios/nrpe.cfg); \
2126 %{-a:# on -a and config exists \
2127 if [ -f /etc/nagios/nrpe.cfg ]; then \
2128 if ! %{__grep} -q '^command\[%{-a*}\]' /etc/nagios/nrpe.cfg; then \
2129 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> /etc/nagios/nrpe.cfg; \
2130 fi; \
2131 fi;} \
2132 %{-d:# on package remove, -d and config exists \
2133 if [ "$1" = "0" -a -f /etc/nagios/nrpe.cfg ]; then \
2134 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' /etc/nagios/nrpe.cfg; \
2135 fi;} \
2136 if [ "$m" != "$(md5sum < /etc/nagios/nrpe.cfg)" ]; then \
2137 %service -q nrpe restart; \
2138 fi; \
2139}%{nil}
2140
2141# Import or update Cacti template.
2142#
2143# Author: Elan Ruusamäe <glen@pld-linux.org>
2144#
2145# Usage:
2146# %cacti_import_template XMLFILE
2147# XMLFILE -- XML template to import
2148#
2149# Sample:
2150# %post
2151# %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
2152#
2153# Requires: cacti >= 0.8.7e-8
2154# BuildRequires: rpmbuild(macros) >= 1.630
2155# Note: 1.1 (cacti-0.8.7h) adds requirement for --with-template-rras or --with-user-rras option
2156
2157%cacti_import_template() {\
2158v=$(%{__sed} -rne 's/.+Add Graphs Script ([0-9\.]+).+/\1/p' /usr/share/cacti/cli/import_template.php); \
2159if [ "$v" != "1.0" ]; then \
2160 rra="--with-template-rras"; \
2161fi; \
2162/usr/share/cacti/cli/import_template.php --filename=%1 $rra || :; \
2163}%{nil}
2164
2165# pre/post script for -upstart subpackages
2166#
2167# Author: Jacek Konieczny <jajcus@jajcus.net>
2168#
2169# Usage:
2170# %upstart_post service_name
2171# %upstart_postun service_name
2172#
2173# Sample:
2174# %post upstart
2175# %upstart_post %{name}
2176#
2177# %postun upstart
2178# %upstart_postun %{name}
2179#
2180# Requirements:
2181# BuildRequires: rpmbuild(macros) >= 1.560
2182# Requires: rc-scripts >= 0.4.3
2183
2184# migrate from init script to upstart job
2185%upstart_post() \
2186 if [ -f /var/lock/subsys/%1 ]; then \
2187 /sbin/service --no-upstart %1 stop \
2188 /sbin/service %1 start \
2189 fi
2190
2191# restart the job after upgrade or migrate to init script on removal
2192# cannot be stopped with 'service' as /etc/init/$name.conf may be missing
2193# at this point
2194%upstart_postun() \
2195 if [ -x /sbin/initctl ] && /sbin/initctl status %1 2>/dev/null | grep -q 'running' ; then \
2196 /sbin/initctl stop %1 >/dev/null 2>&1 \
2197 [ -f /etc/rc.d/init.d/%1 -o -f /etc/init/%1.conf ] && { echo -n "Re-"; /sbin/service %1 start; }; \
2198 fi
2199
2200# Haskell Macros
2201# BuildRequires: rpmbuild(macros) >= 1.608
2202%ghcdir ghc-%(/usr/bin/ghc --numeric-version 2>/dev/null || echo ERROR)
2203
2204# update /usr/lib*/ghc-*/package.conf.d/package.cache
2205# Requires: ghc
2206# BuildRequires: rpmbuild(macros) >= 1.607
2207#
2208%ghc_pkg_recache() {{ \
2209 umask 022; \
2210 [ ! -x /usr/bin/ghc-pkg ] || /usr/bin/ghc-pkg recache; \
2211};} \
2212%{nil}
2213
2214
2215# pre/post script for packages supporting systemd units
2216#
2217# Author: Bartlomiej Zimon <uzi18@o2.pl>
2218# Jan Rękorajski <baggins@mimuw.edu.pl>
2219#
2220# Usage:
2221# %systemd_reload
2222# %systemd_service <unit command> service_name1.service service_name2.service
2223# %systemd_service_enable service_name1.service service_name2.service
2224# %systemd_service_disable service_name1.service service_name2.service
2225# %systemd_service_start service_name1.service service_name2.service
2226# %systemd_service_stop service_name1.service service_name2.service
2227# %systemd_service_restart service_name1.service service_name2.service
2228# %systemd_service_reload service_name1.service service_name2.service
2229#
2230# %systemd_post service_name1.service service_name2.service
2231# %systemd_preun service_name1.service service_name2.service
2232# %systemd_trigger service_name1.service service_name2.service
2233#
2234# Sample:
2235# %post
2236# %systemd_post %{name}.service
2237#
2238# %preun
2239# %systemd_preun %{name}.service
2240#
2241# %postun
2242# %systemd_reload
2243#
2244# %triggerpostun -- %{name} < first-version-with-systemd-units
2245# %systemd_trigger %{name}.service
2246#
2247# Requirements:
2248# BuildRequires: rpmbuild(macros) >= 1.671
2249# Requires: systemd-units >= 38
2250
2251%systemd_reload /bin/systemd_booted && SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog /bin/systemctl --quiet daemon-reload || :
2252
2253%systemd_service_enable() \
2254 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2255 /bin/systemctl --quiet enable %{*} || : \
2256 /bin/systemd_booted && echo 'Run "/bin/systemctl start %{*}" to start %{*}.' || : \
2257%{nil}
2258
2259%systemd_service_disable() \
2260 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2261 /bin/systemctl --quiet disable %{*} || : \
2262%{nil}
2263
2264%systemd_service() \
2265 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2266 /bin/systemd_booted && /bin/systemctl --quiet %{*} || : \
2267%{nil}
2268
2269%systemd_service_start() \
2270 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2271 /bin/systemd_booted && /bin/systemctl --quiet start %{*} || : \
2272%{nil}
2273
2274%systemd_service_stop() \
2275 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2276 /bin/systemd_booted && /bin/systemctl --quiet stop %{*} || : \
2277%{nil}
2278
2279%systemd_service_restart() \
2280 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2281 /bin/systemd_booted && /bin/systemctl --quiet try-restart %{*} || : \
2282%{nil}
2283
2284%systemd_service_reload() \
2285 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2286 /bin/systemd_booted && /bin/systemctl --quiet reload %{*} || : \
2287%{nil}
2288
2289%systemd_trigger() \
2290want_enable_service() { \
2291 [ -f /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
2292 [ ${RPM_ENABLE_SYSTEMD_SERVICE:-yes} = no ] && return 1 \
2293 [ "$(echo /etc/rc.d/rc[0-6].d/S[0-9][0-9]${1%.service})" = "/etc/rc.d/rc[0-6].d/S[0-9][0-9]${1%.service}" ] && return 1 \
2294 return 0 \
2295}\
2296 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2297 for s in %{*}; do \
2298 if want_enable_service $s; then \
2299 /bin/systemctl --quiet enable $s || : \
2300 fi \
2301 done \
2302%{nil}
2303
2304%systemd_post() \
2305 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2306 /bin/systemd_booted && /bin/systemctl --quiet daemon-reload || : \
2307 if [ $1 -eq 1 ]; then \
2308 /bin/systemctl --quiet enable %{*} || : \
2309 /bin/systemd_booted && echo 'Run "/bin/systemctl start %{*}" to start %{*}.' || : \
2310 elif [ -z "$NORESTART" ]; then \
2311 /bin/systemd_booted && /bin/systemctl --quiet try-restart %{*} || : \
2312 else \
2313 /bin/systemd_booted && echo 'Run "/bin/systemctl restart %{*}" to restart %{*}.' || : \
2314 fi \
2315%{nil}
2316
2317%systemd_preun() \
2318 if [ $1 -eq 0 ]; then \
2319 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2320 /bin/systemd_booted && /bin/systemctl --quiet stop %{*} || : \
2321 /bin/systemctl --quiet disable %{*} || : \
2322 fi \
2323%{nil}
2324
2325%systemdunitdir /lib/systemd/system
2326%systemdtmpfilesdir /usr/lib/tmpfiles.d
2327
2328# EOF
This page took 0.069716 seconds and 4 git commands to generate.